# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from .list_models_request import ListModelsRequest


class PaginatedModelListPostNextRequest(ListModelsRequest):
    """A request body(payload) to the next page of results in the list.

    :param name: The object name.
    :type name: str
    :param tag: The object tag.
    :type tag: str
    :param version: The object version.
    :type version: str
    :param framework: The framework.
    :type framework: str
    :param description: The object description.
    :type description: str
    :param count: The number of items to retrieve in a page.
    :type count: int
    :param offset: The (zero-based) offset of the first item in the collection
     to return continuation token to retrieve the next page.
    :type offset: int
    :param skip_token: The continuation token to retrieve the next page.
    :type skip_token: str
    :param tags: A set of tags with which to filter the returned models.
     It is a comma separated string of tags key or tags key=value
     Example: tagKey1,tagKey2,tagKey3=value3 .
    :type tags: str
    :param properties: A set of properties with which to filter the returned
     models.
     It is a comma separated string of properties key and/or properties
     key=value
     Example: propKey1,propKey2,propKey3=value3 .
    :type properties: str
    :param run_id: The runId which created the model.
    :type run_id: str
    :param dataset_id: The datasetId associated with the model.
    :type dataset_id: str
    :param order_by: The option to order the response. Possible values
     include: 'CreatedAtDesc', 'CreatedAtAsc', 'UpdatedAtDesc', 'UpdatedAtAsc'
    :type order_by: str or ~_restclient.models.OrderString
    :param latest_version_only: An option to get only the latest version of
     the models in the response.
    :type latest_version_only: bool
    """

    def __init__(self, name=None, tag=None, version=None, framework=None, description=None, count=None, offset=None, skip_token=None, tags=None, properties=None, run_id=None, dataset_id=None, order_by=None, latest_version_only=None):
        super(PaginatedModelListPostNextRequest, self).__init__(name=name, tag=tag, version=version, framework=framework, description=description, count=count, offset=offset, skip_token=skip_token, tags=tags, properties=properties, run_id=run_id, dataset_id=dataset_id, order_by=order_by, latest_version_only=latest_version_only)
